Loading...
Searching...
No Matches
seqan3::rna4 Class Reference
Alphabet » Nucleotide

The four letter RNA alphabet of A,C,G,U. More...

`#include <seqan3/alphabet/nucleotide/rna4.hpp>`

Inheritance diagram for seqan3::rna4:
[legend]

## Public Member Functions

Constructors, destructor and assignment
constexpr | rna4 () noexcept=default
| Defaulted.
constexpr | rna4 (rna4 const &) noexcept=default
| Defaulted.
constexpr | rna4 (rna4 &&) noexcept=default
| Defaulted.
constexpr rna4 & | operator= (rna4 const &) noexcept=default
| Defaulted.
constexpr rna4 & | operator= (rna4 &&) noexcept=default
| Defaulted.
| ~rna4 () noexcept=default
| Defaulted.
template<std::same_as< dna4 > t>
constexpr | rna4 (t const &r) noexcept
| Allow implicit construction from seqan3::dna4 of the same size.
Public Member Functions inherited from seqan3::nucleotide_base< rna4, 4 >
constexpr rank_type | to_rank () const noexcept
| Return the letter's numeric value (rank in the alphabet).
constexpr rna4 | complement () const noexcept
| Return the complement of the letter.
constexpr | nucleotide_base (other_nucl_type const &other) noexcept
| Allow explicit construction from any other nucleotide type and convert via the character representation.
Public Member Functions inherited from seqan3::alphabet_base< derived_type, size, char_t >
constexpr | alphabet_base () noexcept=default
| Defaulted.
constexpr | alphabet_base (alphabet_base const &) noexcept=default
| Defaulted.
constexpr | alphabet_base (alphabet_base &&) noexcept=default
| Defaulted.
constexpr alphabet_base & | operator= (alphabet_base const &) noexcept=default
| Defaulted.
constexpr alphabet_base & | operator= (alphabet_base &&) noexcept=default
| Defaulted.
| ~alphabet_base () noexcept=default
| Defaulted.
constexpr char_type | to_char () const noexcept
| Return the letter as a character of char_type.
constexpr rank_type | to_rank () const noexcept
| Return the letter's numeric value (rank in the alphabet).
constexpr derived_type & | assign_char (char_type const chr) noexcept
| Assign from a character, implicitly converts invalid characters.
constexpr derived_type & | assign_rank (rank_type const c) noexcept
| Assign from a numeric value.

## Related Symbols

(Note that these are not member symbols.)
using | rna4_vector = std::vector<rna4>
| Alias for a std::vector of seqan3::rna4.
Nucleotide literals
constexpr rna4 | operator""_rna4 (char const c) noexcept
| The seqan3::rna4 char literal.
constexpr rna4_vector | operator""_rna4 (char const *s, std::size_t n)
| The seqan3::rna4 string literal.

## Additional Inherited Members

Static Public Member Functions inherited from seqan3::nucleotide_base< rna4, 4 >
static constexpr bool | char_is_valid (char_type const c) noexcept
| Validate whether a character value has a one-to-one mapping to an alphabet value.
Static Public Attributes inherited from seqan3::nucleotide_base< rna4, 4 >
static constexpr detail::min_viable_uint_t< size > | alphabet_size
| The size of the alphabet, i.e. the number of different values it can take.
Static Public Attributes inherited from seqan3::alphabet_base< derived_type, size, char_t >
static constexpr detail::min_viable_uint_t< size > | alphabet_size = size
| The size of the alphabet, i.e. the number of different values it can take.
Protected Types inherited from seqan3::alphabet_base< derived_type, size, char_t >
using | char_type = std::conditional_t<std::same_as<char_t, void>, char, char_t>
| The char representation; conditional needed to make semi alphabet definitions legal.
using | rank_type = detail::min_viable_uint_t<size - 1>
| The type of the alphabet when represented as a number (e.g. via to_rank()).

## Detailed Description

The four letter RNA alphabet of A,C,G,U.

This alphabet has the same internal representation as seqan3::dna4, the only difference is that it prints 'U' on character conversion instead of 'T'. You can assign between values of seqan3::dna4 and seqan3::rna4.

Like most alphabets, this alphabet cannot be initialised directly from its character representation. Instead initialise/assign from the character literal 'A'_rna4 or use the function seqan3::rna4::assign_char().

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
#include <seqan3/alphabet/nucleotide/rna4.hpp>
#include <seqan3/core/debug_stream.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::rna4 letter{'A'_rna4};
letter.assign_char('C');
seqan3::debug_stream << letter << '\n'; // prints "C"
letter.assign_char('F'); // Unknown characters are implicitly converted to A.
seqan3::debug_stream << letter << '\n'; // prints "A"
}
seqan3::alphabet_base::assign_char
constexpr derived_type & assign_char(char_type const chr) noexcept
Assign from a character, implicitly converts invalid characters.
Definition alphabet_base.hpp:160
seqan3::rna4
The four letter RNA alphabet of A,C,G,U.
Definition rna4.hpp:46
debug_stream.hpp
Provides seqan3::debug_stream and related types.
seqan3::debug_stream
debug_stream_type debug_stream
A global instance of seqan3::debug_stream_type.
Definition debug_stream.hpp:38
seqan3::literals
The SeqAn namespace for literals.
rna4.hpp
Provides seqan3::rna4, container aliases and string literals.

This entity is stable. Since version 3.1.

## Constructor & Destructor Documentation

## rna4()

template<std::same_as< dna4 > t>

seqan3::rna4::rna4 | ( | t const & | r | ) |

inline constexpr noexcept

Allow implicit construction from seqan3::dna4 of the same size.

Normally, we do not allow implicit conversion of single argument constructors, but in this case we make an exception, because seqan3::rna4 and seqan3::dna4 are interchangeable as they behave nearly the same (e.g. same ranks, same char to rank conversion).

#include <seqan3/alphabet/nucleotide/dna4.hpp>
#include <seqan3/alphabet/nucleotide/rna4.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::rna4 letter1 = 'C'_dna4; // implicitly converted
seqan3::rna4 letter2{};
letter2 = 'C'_dna4; // implicitly converted
}

seqan3::sequences (e.g. seqan3::rna4_vector) in general are not implicitly convertible and must be explicitly copied to be converted:

#include <vector>
#include <seqan3/alphabet/nucleotide/dna4.hpp>
#include <seqan3/alphabet/nucleotide/rna4.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::rna4_vector vector{'A'_dna4, 'C'_dna4, 'G'_dna4}; // (element-wise) implicit conversion
// but this won't work:
// seqan3::rna4_vector rna4_vector{"ACGT"_dna4};
// as a workaround you can use:
// side note: this would also work without the implicit conversion.
seqan3::dna4_vector dna4_vector = "ACGT"_dna4;
seqan3::rna4_vector rna4_vector{dna4_vector.begin(), dna4_vector.end()};
}

You can avoid this copy by using std::ranges::views:

#include <vector>
#include <seqan3/alphabet/nucleotide/dna4.hpp>
#include <seqan3/alphabet/nucleotide/rna4.hpp>
#include <seqan3/utility/views/convert.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::rna4_vector vector = "ACG"_rna4;
auto dna4_view = vector | seqan3::views::convert<seqan3::dna4>;
for (auto && chr : dna4_view) // converts lazily on-the-fly
{
static_assert(std::same_as<decltype(chr), seqan3::dna4 &&>);
}
}

This conversion constructor only allows converting seqan3::dna4 to seqan3::rna4. Other alphabets that inherit from seqan3::dna4 will not be implicitly convertible to seqan3::rna4.

#include <seqan3/alphabet/nucleotide/dna4.hpp>
#include <seqan3/alphabet/nucleotide/rna4.hpp>
struct my_rna4 : public seqan3::rna4
{
// using seqan3::rna4::rna4; // uncomment to import implicit conversion shown by letter1
};
struct my_dna4 : public seqan3::dna4
{};
int main()
{
using namespace seqan3::literals;
// my_rna4 letter1 = 'C'_dna4; // NO automatic implicit conversion!
// seqan3::rna4 letter2 = my_dna4{}; // seqan3::rna4 only allows implicit conversion from seqan3::dna4!
}

This entity is stable. Since version 3.1.

## Friends And Related Symbol Documentation

## operator""_rna4() [1/2]

rna4_vector operator""_rna4 | ( | char const * | s,
|  | std::size_t | n )

related

The seqan3::rna4 string literal.

Returns
  seqan3::rna4_vector

You can use this string literal to easily assign to rna4_vector:

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
// generated from test/snippet/alphabet/nucleotide/@target_alphabet@_literal.cpp.in
#include <seqan3/alphabet/nucleotide/rna4.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::rna4_vector sequence1{"ACGTTA"_rna4};
seqan3::rna4_vector sequence2 = "ACGTTA"_rna4;
auto sequence3 = "ACGTTA"_rna4;
}

This entity is stable. Since version 3.1.

## operator""_rna4() [2/2]

rna4 operator""_rna4 | ( | char const | c | ) |

related

The seqan3::rna4 char literal.

Returns
  seqan3::rna4

You can use this char literal to assign a seqan3::rna4 character:

#include <seqan3/alphabet/nucleotide/rna4.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::rna4 letter1{'A'_rna4};
auto letter2 = 'A'_rna4;
}

This entity is stable. Since version 3.1.

## rna4_vector

using rna4_vector = std::vector<rna4>

related

Alias for a std::vector of seqan3::rna4.

This entity is stable. Since version 3.1.

The documentation for this class was generated from the following file:

- rna4.hpp

Hide me